function print_tt(colNumber, rowNumber, schoolName) {

    var ctt = new ClassTimeTable(colNumber, rowNumber);
    if (schoolName != undefined) {
        ctt.setSchoolname(schoolName);
    }

    var nowDate = ctt.cYear.toString() + 'N' + ctt.cMonth.toString() + '' + ctt.cDate.toString() + '' + ctt.daysArray[ctt.cDay] + 'j';
    var nowTime = ctt.cHours.toString() + '' + ctt.cMinutes.toString() + '' + ctt.cSeconds.toString() + 'b';

    var nextClass = ctt.getNextclass();
    var currentClass = ctt.getCurrentclass()

    var announceTime = 'ݎ<strong class="time_announce">' + nowDate + ' ' + nowTime + '</strong>B';
    if (ctt.inClass()) {
        announceTime += '<strong class="class_announce">' + currentClass + '</strong>JuB';
    }
    var announceClass = '̎Ƃ<strong class="class_announce">' + nextClass + '</strong>łB';

    ctt.printTable();
    ctt.printP(announceClass, 'tmo_announce_class');
    ctt.printP(announceTime, 'tmo_announce_time');
}

function printP(content, classname) {
    if (classname == undefined) {
        document.write('<p>');
    } else {
        document.write('<p class="');
        document.write(classname);
        document.write('">');
    }
    document.write(content);
    document.write('</p>');
}

function printTable() {
    var cols = (this.colNumber - 1) / 2;
    var rows = (this.rowNumber - 1) / 2;

    var tableName = this.getTablename();
    if (tableName == undefined) {
        tableName = this.schoolName + 'Ԋ';
    }

    document.write('<table class="tmo_ctt">');
    document.write('<caption>' + tableName + '</caption>');
    document.write('<col class="clock_time">');
    for (var i = cols * -1; i <= cols; i++) {
        if (i == 0) {
            document.write('<col class="today">');
        } else {
            document.write('<col class="days">');
        }
    }
    document.write('<thead><tr><td>&nbsp;</td>');
    for (var i = cols * -1; i <= cols; i++) {
        var dayNum = this.cDay + i;
        if (dayNum < 0) {
            dayNum += 7;
        }
        if (dayNum > 6) {
            dayNum -= 7;
        }
        var dayName = this.daysArray[dayNum];
        document.write('<th>');
        document.write(dayName);
        document.write('</th>');
    }
    document.write('</tr></thead>');

    var tbodyClass;
    for (var i = rows * -1; i <= rows; i++) {
        var cTime = this.cTime;
        cTime += ((i + 1) * 15 * 60 * 1000);
        var tTime = new Date();
        tTime.setTime(cTime);
        var tHours = tTime.getHours();
        var tMinutes = tTime.getMinutes();
        if (tMinutes < 15) {
            tMinutes = 0;
        } else if (tMinutes < 30) {
            tMinutes = 15;
        } else if (tMinutes <45) {
            tMinutes = 30;
        } else if (tMinutes < 60) {
            tMinutes = 45;
        }

        if ((tHours == 0 && tMinutes == 0) || i == rows * -1) {
            if (tbodyClass != undefined) {
                document.write('</tbody>');
            }
            if (tTime.getDate() < this.cDate) {
                tbodyClass = '<tbody class="past">';
            } else if (tTime.getDate() == this.cDate) {
                tbodyClass = '<tbody class="present">';
            } else if (tTime.getDate() > this.cDate) {
                tbodyClass = '<tbody class="future">';
            }
            document.write(tbodyClass);
        }

        var tHead = tHours.toString();
        if (tHours.toString().length == 1) {
            tHead = '0' + tHead;
        }
        if (tMinutes.toString().length == 1) {
            tHead += ':0' + tMinutes.toString();
        } else {
            tHead += ':' + tMinutes.toString();
        }
        if (i == 0) {
            document.write('<tr class="nexttime"><th>');
        } else {
            document.write('<tr><th>');
        }
        document.write(tHead);
        document.write('</th>')
        for (var j = cols * -1; j <= cols; j++) {
            var cTime = this.cTime;
            cTime += ((i + 1) * 15 * 60 * 1000);
            cTime += j * 24 * 60 * 60 * 1000;
            var tTime = new Date();
            tTime.setTime(cTime);
            var dayNum = tTime.getDay();
            var classId = this.getClassid(dayNum, tHours, tMinutes);
            var className = this.classArray[classId];
            if (i == 0 && j == 0) {
                this.printTd(className, 'next');
            } else {
                this.printTd(className);
            }
        }
        document.write('</tr>')
    }
    document.write('</tbody>');
    document.write('</table>');
}

function printTd(content, classname) {
    if (classname == undefined) {
        document.write('<td>');
    } else {
        document.write('<td class="');
        document.write(classname);
        document.write('">');
    }
    document.write(content);
    document.write('</td>');
}

function getCurrentclass() {
    var tDay = this.cDay;
    var tHours = this.cHours;
    var tMinutes = this.cMinutes;
    
    var classId = this.getClassid(tDay, tHours, tMinutes);
    var className = this.getClassname(classId);

    return className;
}

function getNextclass() {
    var tDay = this.cDay;
    var tHours = this.cHours;
    var tMinutes = this.cMinutes;
    
    tMinutes += 15;
    if (tMinutes >= 60) {
        tMinutes %= 60;
        tHours += 1;
    }
    if (tHours >= 24) {
        tHours %= 24;
        tDay += 1;
    }
    if (tDay >= 7) {
        tDay %= 7;
    }
    var classId = this.getClassid(tDay, tHours, tMinutes);
    var className = this.getClassname(classId);

    return className;
}

function getClassname(classId) {
    var className = this.classArray[classId];
    return className;
}

function getClassid(tDay, tHours, tMinutes) {
    if (tDay == undefined) {
        tDay = this.cDay;
    }
    if (tHours == undefined) {
        tHours = this.cHours;
    }
    if (tMinutes == undefined) {
        tMinutes = this.cMinutes;
    }
    var classId = 0;
    if (tHours % 2 == 1) {
        classId = 4;
    }
    classId += tDay;
    classId += Math.floor(tMinutes / 15);
    if (tDay == 0) {
        classId -= 2;
    } else {
        classId -= 1;
    }
    if (classId < -1) {
        classId = 6;
    } else if (classId < 0) {
        classId = 7;
    }
    classId %= 8;

    return classId;
}

function setTablename(tableName) {
    this.tableName = tableName;
}

function getTablename() {
    return this.tableName;
}

function setSchoolname (schoolName) {
    this.schoolName = schoolName;
}

function setColnumber(colNumber) {
    if (colNumber == undefined) {
        this.colNumber = 7;
    } else if (colNumber % 2 == 0) {
        this.colNumber = colNumber + 1;
    } else {
        this.colNumber = colNumber;    
    }
    if (this.colNumber > 7) {
        this.colNumber = 7;
    }
}

function setRownumber(rowNumber) {
    if (rowNumber == undefined) {
        this.rowNumber = 7;
    } else if (rowNumber % 2 == 0) {
        this.rowNumber = rowNumber + 1;
    } else {
        this.rowNumber = rowNumber;
    }
}

function inClass(cMinutes) {
    if (cMinutes == undefined) {
        cMinutes = this.cMinutes;
    }
    if (cMinutes % 15 < this.courseHour) {
        return true;
    } else {
        return false;
    }
}

function ClassTimeTable(colNumber, rowNumber) {
    this.courseHour = 6;
    this.schoolName = '̍Z';
    this.tableName;
    this.daysArray = new Array('', '', '', '', '', '', 'y');
    this.classArray = new Array('', 'w', '', 'Љ', 'O', '̈', '|p', 'ƒ');
    var objDate = new Date();

    this.cYear = objDate.getFullYear();
    this.cMonth = objDate.getMonth();
    this.cMonth += 1;
    this.cDate = objDate.getDate();
    this.cDay = objDate.getDay();
    this.cHours = objDate.getHours();
    this.cMinutes = objDate.getMinutes();
    this.cSeconds = objDate.getSeconds();
    this.cTime = objDate.getTime();

    if (colNumber == undefined) {
        this.colNumber = 7;
    } else if (colNumber % 2 == 0) {
        this.colNumber = colNumber + 1;
    } else {
        this.colNumber = colNumber;    
    }
    if (this.colNumber > 7) {
        this.colNumber = 7;
    }
    
    if (rowNumber == undefined) {
        this.rowNumber = 7;
    } else if (rowNumber % 2 == 0) {
        this.rowNumber = rowNumber + 1;
    } else {
        this.rowNumber = rowNumber;
    }
}

new ClassTimeTable();
ClassTimeTable.prototype.printP = printP;
ClassTimeTable.prototype.printTable = printTable;
ClassTimeTable.prototype.printTd = printTd;
ClassTimeTable.prototype.getCurrentclass = getCurrentclass;
ClassTimeTable.prototype.getNextclass = getNextclass;
ClassTimeTable.prototype.getClassname = getClassname;
ClassTimeTable.prototype.getClassid = getClassid;
ClassTimeTable.prototype.setTablename = setTablename;
ClassTimeTable.prototype.getTablename = getTablename;
ClassTimeTable.prototype.setSchoolname = setSchoolname;
ClassTimeTable.prototype.setColnumber = setColnumber;
ClassTimeTable.prototype.setRownumber = setRownumber;
ClassTimeTable.prototype.inClass = inClass;
